cards.push({
    id: "login",
    title: "Login",
    url: config.baseUrl + "login",
    events: function () {
        $(".login-register").on(tap_event, function () {
            loadCard("register");
        });

        $(".submit-login-form").on(tap_event, function () {
            var username = $("#login-username").val();
            var password = $("#login-password").val();
            var result = parseAdapter.tryLogin(username, password,
                function (result) {
                    if (result.success == false) {

                        woofer.pushErrorsToUI(result);
                    }
                    else {
                        woofer.userLoggedIn();
                    }
                });
        });
    },
    beforeShow: function (args) {
        if (Parse.User.current()) {

            var force = false;
            if(args.params && args.params.force) force = args.params.force;
            if(force !== true){
                woofer.userLoggedIn();
                return false;
            }
        }
    }
});
cards.push({
    id: "register",
    title: "Register",
    url: config.baseUrl + "register",
    events: function () {
        $(".submit-register-form").on(tap_event, function () {
            console.log("Submitted register.");
            $(".submit-register-form").attr('disabled',true);

            var tpl = _.template($("#waitingForData").html());
            var compiled = tpl({});
            $(".card[data-card-id=register] .waiting").append(compiled);

            var result = parseAdapter.tryRegister(
                $("#register-first-name").val(),
                $("#register-last-name").val(),
                $("#register-email").val(),
                $("#register-password").val(),

                function (result) {

                    $(".card[data-card-id=register] .waiting").html("");
                    $(".submit-register-form").attr('disabled',false);
                    if (result.success == false) {
                        console.log("Register failed");
                        woofer.pushErrorsToUI(result);
                    }
                    else {
                        console.log("Register successful, open swal.");
                        swalevent = function(){woofer.userLoggedIn();};
                        swal("Register successful!","");
                    }
                }
            );

        });
        $("#register-password").removeAttr("onmousedown");
        $(".clear-register-form").on(tap_event, function () {
            $("#register-first-name").val("");
            $("#register-last-name").val("");
            $("#register-email").val("");
            $("#register-password").val("");
        })
    },
    afterShow: function(){
    }
});
cards.push({
    id: "terms",
    title: "Terms and Conditions",
    url: config.baseUrl + "terms",
    afterShow: function () {
        var terms_height = $(window).height() - $(".active_card").find(".button-row").height() - $(".active_card").find(".header").height() - 80;
        $("#terms-text").css({height: terms_height});
        $("#terms-text").text(woofer.dynamicConfig.termsConditions);
    },
    events: function () {
        $(".terms-decline-terms").on(tap_event, function () {
            swal({title: "Oops...", text: "You have to accept the conditions to continue."});
        });
        $(".terms-accept-terms").on(tap_event, function () {
            Parse.User.current().set('termsAndConditionsAgreedDate', new Date());
            Parse.User.current().set('termsAndConditionsAgreedVersion', woofer.dynamicConfig.termsConditionsVersion);
            Parse.User.current().save(null, {
                success: function (user) {
                    woofer.userAllowedIn();
                },
                error: function (user, error) {
                    swal("",error.message);
                    console.log(error.message);
                }
            });

        });

    }
});
cards.push({
    id: "no-location",
    title: "No Location",
    showIconBar: true,
    url: config.baseUrl + "no-location",
    afterShow: function () {

    },
    events: function () {


    }
});
cards.push({
    id: "friends-upgrading",
    title: "Friends upgrading",
    showIconBar: true,
    url: config.baseUrl + "friends-upgrading",
    afterShow: function () {

    },
    events: function () {


    }
});


cards.push({
    id: "report-a-problem",
    title: "Report A Problem",
    showIconBar: true,
    url: config.baseUrl + "report-a-problem",
    afterShow: function () {
        woofer.resetReportProblemForm();
    },
    events: function () {

            $(".submit-problem").on(tap_event,function(){

                var problem_type = $(".rap-dropdown-selected").text();
                var problem_text = $("#problem-text-body").val();
                if(problem_type == ""){
                    swal("","Please choose a problem from the dropdown menu.");
                    return;
                }
                if(problem_text == ""){
                    swal("", "Please enter some details about your problem.");
                    return;
                }
                $(".submit-problem").attr('disabled', true);
                Parse.Cloud.run("emailWoofer", {
                    problem_type: problem_type,
                    problem_text: problem_text,
                    email: Parse.User.current().attributes.email
                }, {success: function(){
                        swal("Report submitted!", "Your error report was submitted successfully!");

                }, error: function(e){
                    $(".submit-problem").attr('disabled', false);

                }});
            });
        $(".rap-dropdown-selected").on(tap_event, function(){
            $(".dropdown-items").toggle();
        })
        $("body").on(tap_event, ".dropdown-items button", function(){
            var text = $(this).text();
            $(".dropdown-items").hide();
            $(".rap-dropdown-selected").text(text);
        });
        $("body").on(tap_event, '.clear-rap', function(){
            woofer.resetReportProblemForm();
        })

    }
});
cards.push({
    id: "menu",
    title: "Menu",
    url: config.baseUrl + "menu",
    afterShow: null,
    beforeShow: null,
    events: function () {
        var m = $(".container.menu");
        m.find(".edit-kennel").on(tap_event, function () {
            loadCard("myProfile");
        });
        m.find(".barking").on(tap_event, function () {
            loadCard("messages");
        });
        m.find(".pack").on(tap_event, function () {
            loadCard("friends");
        });
        m.find(".sniff-button").on(tap_event, function () {
            loadCard("profilesAround");
        });
        m.find(".find-a-park").on(tap_event, function () {
            loadCard("findAPark");
        });
        m.find(".terms").on(tap_event, function () {
            loadCard("terms");
        });
        m.find(".logout").on(tap_event, function () {
            swal({title: "Are you sure?", text: "<button class='woofer yes-logout'>Log me out</button><br /><button class='woofer nevermind'>No, nevermind</button>", showConfirmButton: false });

        });
        m.find(".report-a-problem").on(tap_event, function () {
            loadCard("report-a-problem");

        });
        $("body").on('click','.yes-logout',function(){
            Parse.User.logOut();
            window.swal_closeModal();
            loadCard("login");
        });
        $("body").on('click','.nevermind',function(){
                window.swal_closeModal();
            }
        );
    }
});
cards.push({
    id: "myProfile",
    title: "My Profile",
    showIconBar: true,
    url: config.baseUrl + "myProfile",
    beforeShow: function () {
        woofer.setActive(this.id);

        var mp = $(".myProfile");



    /*    mp.find(".gender").attr('data-gender',"undefined");
        mp.find(".age").attr('data-age',"undefined");
        mp.find(".microchipped").attr('data-microchipped',"undefined");
        mp.find(".trained").attr('data-trained',"undefined");
        mp.find(".vaccinated").attr('data-vaccinated',"undefined");
        mp.find(".desexed").attr('data-desexed',"undefined");
        mp.find(".dogname > .name").text("(Enter name)");
        mp.find(".dogname > .breed").text("(Select Breed)");
        mp.find(".dog_photo > img").addClass("no_photo");*/
            // if the profile is being requested, keep cehcking every 200ms, and cancel when found.
            if(state.requestingMyProfile){
                var keepCheckingRetrievingProfile = setInterval(function(){

                    if(!state.requestingMyProfile){
                        clearInterval(keepCheckingRetrievingProfile);
                        if(dataCache.profile){
                            woofer.displayMyProfile();
                            loadCard("myProfile");
                        }

                    }
                }, 200);

                var tpl = _.template($("#waitingForData").html());
                var compiled = tpl({});
                $(".active_card").append(compiled);


                return false;
            }

    },
    afterShow: function () {

        woofer.setHeightKennel();

        var hasSeenTip = false;
        if(Parse.User.current().attributes.hasSeenEditTip != undefined){
            hasSeenTip =Parse.User.current().attributes.hasSeenEditTip;
        }
        if(!hasSeenTip){
            swal("Hint...",  "<img class='img-tap' src='" + blankImage + "'><br>  TAP icons to edit your kennel.");
            //Parse.User.current().attributes.hasSeenSwipeTip = true;
            Parse.User.current().set('hasSeenEditTip',true);
            Parse.User.current().save();
        }

        if($(".myProfile .dogname .name").prop('scrollWidth') > $(".myProfile .dogname .name").width() ||
            $(".myProfile .dogname .name").height() > 45
        ){
            $(".myProfile .dogname .name").css({fontSize:"12pt"});

        }

    },
    events: function () {
        var srcType = {
            PHOTOLIBRARY: 0,
            CAMERA: 1,
            SAVEDPHOTOALBUM: 2
        };
        var mp = $(".myProfile");
        $("body").on('change',"#dob-picker",function(){
            var dob = $("#dob-picker").val();
            dobmoment = new moment(dob, "YYYY-MM-DD");
            if(dobmoment > new moment()){
                $(".confirm.woofer").prop('disabled',true);
                $(".you-cant-future").show();
            }
            else{
                $(".confirm.woofer").prop('disabled',false);
                $(".you-cant-future").hide();
            }
        });
        mp.find(".age").on(tap_event, function () {
            var that = $(this);

            swalevent = function(){
                var dob = $("#dob-picker").val();
                dobmoment = new moment(dob, "YYYY-MM-DD");
                var yo = dobmoment.fromNow(true).replace("years","").trim();

                if(yo.indexOf("months") > 0){
                    yo = 0;
                }
                if(yo >= 20){
                    yo = 20;
                }

                that.attr('data-age', yo);
                //alert(dobmoment.format("DD/MM/YYYY"));
                that.attr('data-dateOfBirth', dob);

                woofer.saveMyProfile();
            };
            var existing_dob = that.attr('data-dateOfBirth');
            var defaultValue = "";
            if(existing_dob){
                defaultValue = moment(existing_dob).format("YYYY-MM-DD");
            }

            var swaltext = "Enter your dogs birth below:<br>" +
                "<span class='you-cant-future' style='display:none;'>That's in the future!</span>"
                +"<input type='date' id='dob-picker' value='"+defaultValue+"' />"
            swal("Date of Birth?", swaltext);
        });
        mp.find(".gender").on(tap_event, function () {
            var current_gender = $(this).attr('data-gender');
            if (current_gender == "undefined") {
                current_gender = "female";
            }
            current_gender = current_gender == "female" ? "male" : "female";
            $(this).attr('data-gender', current_gender);
        });
        mp.find(".microchipped").on(tap_event, function () {
            var state = $(this).attr('data-microchipped');
            if (state == "undefined") state = "false";
            state = state == "false" ? "true" : "false";
            $(this).attr('data-microchipped', state);
        });
        mp.find(".vaccinated").on(tap_event, function () {
            var state = $(this).attr('data-vaccinated');
            if (state == "undefined") state = "false";
            state = state == "false" ? "true" : "false";
            $(this).attr('data-vaccinated', state);
        });
        mp.find(".desexed").on(tap_event, function () {
            var state = $(this).attr('data-desexed');
            if (state == "undefined") state = "false";
            state = state == "false" ? "true" : "false";
            $(this).attr('data-desexed', state);
        });
        mp.find(".trained").on(tap_event, function () {
            var state = $(this).attr('data-trained');
            if (state == "undefined") state = "false";
            state = state == "false" ? "true" : "false";
            $(this).attr('data-trained', state);
        });
        mp.find(".name").on(tap_event, function () {

            var editNameContents = $("#editNameTemplate");


            /* $(".name").text(swal_box.find(".name_entry").val());
             $(".breed").text(swal_box.find(".breed_selector").val());*/

            var existing_name = mp.find(".name").text();
            if(existing_name == "(Enter name)"){
                existing_name = "";
            }
            var existing_breed = mp.find(".breed").text();
            swalevent = function(){

                //user has entered their name and breed.

                var swal_box = $(".sweet-alert");
                var name = swal_box.find(".name_entry").val();

                if(name == ""){
                    name = "(Enter name)";
                }
                $(".name").text(name);
                var breed = swal_box.find(".breed_selector").val();
                if(breed != "Select Breed:"){
                    $(".breed").text(breed);
                }
                woofer.saveMyProfile();
            };
            swal("Name and breed:", editNameContents.html());
            $(".sweet-alert").find(".name_entry").val(existing_name);
            $(".sweet-alert").find(".breed_selector").val(existing_breed);
        });
        mp.find(".dog_photo").find("img").on(tap_event, function(){

            swal({title:"Photo location",
                text:"<button class='woofer camera-chosen'>Camera</button><br /><button class='woofer gallery-chosen'>My photos</button>",
            showConfirmButton: true});
            return;

        });
        mp.find(".my-photo-album").on(tap_event, function(){
            //bring up photo gallery.
            var pg_tpl = _.template($("#photoGalleryTemplate").html());
            var args = {photo1: "", photo2: "", photo3: "", photo4: ""};

            try{
                args.photo1 =
                    dataCache.profile.get("photo").url();
            } catch(e){}
            try{
                args.photo2 =
                    dataCache.profile.get("photo2").url();
            } catch(e){}
            try{
                args.photo3 =
                    dataCache.profile.get("photo3").url();
            } catch(e){}
            try{
                args.photo4 =
                    dataCache.profile.get("photo4").url();
            } catch(e){}
            var compiled = pg_tpl({args: args});
            compiled = compiled.split("\n").join("");
            swal({title: "Photo gallery",
            text: compiled, showConfirmButton:true});
        });
        $("body").on(tap_event, '.photo-gallery', function(){
            $(".photo-gallery").removeClass("active");
            $(this).addClass("active");
            $(".update-photo").show();
            $(".photo-selected").removeAttr('disabled');
            $(".photo-source").hide();
        });

        $("body").on(tap_event, '.use-as-cover', function(){
            var jqphotoToUse = $(".photo-gallery.active");
            var field = jqphotoToUse.attr('data-field');
            dataCache.profile.set("coverPhoto", field);
            dataCache.profile.save();
            var imgtag = mp.find(".dog_photo").find("img");
            imgtag.attr('src', jqphotoToUse.attr('src'));
            // $(".profilesAround .dog_photo img").css({marginLeft: ($(".profilesAround .dog_photo").width() - $(".profilesAround .dog_photo img").width())/2});
            window.swal_closeModal();
        });

        //user is updating a photo in their set.
        $("body").on(tap_event, '.photo-source-gallery', function(){
            //which photo is it?
            var field = $(".photo-gallery.active").attr('data-field');
            woofer.getDogPhoto(srcType.SAVEDPHOTOALBUM, field);
        });

        $("body").on(tap_event, '.photo-source-camera', function(){
            //which photo is it?
            var field = $(".photo-gallery.active").attr('data-field');
            woofer.getDogPhoto(srcType.CAMERA, field);
        });

        $(".trigger-profile-save").on(tap_event, function () {
            woofer.saveMyProfile();
        });
        $("body").on(tap_event,'.camera-chosen',function(){
            window.swal_closeModal();
            //take a photo.
            console.log("Take a photo tapped.");
            var field = dataCache.profile ? dataCache.profile.get("coverPhoto") : "photo";
            if(field == undefined) field = "photo";
            woofer.getDogPhoto(srcType.CAMERA, field);
        });
        $("body").on(tap_event, '.update-photo', function(){
            $(".update-photo").hide();
            $(".photo-source").show();
        })
        $("body").on(tap_event,'.gallery-chosen',function(){
            window.swal_closeModal();
            console.log("Choose a photo tapped.");
            var field = dataCache.profile ? dataCache.profile.get("coverPhoto") : "photo";
            if(field == undefined) field = "photo";
            woofer.getDogPhoto(srcType.SAVEDPHOTOALBUM, field);
        });
    }
});
cards.push({
    id: "profilesAround",
    title: "Profiles Around",
    showIconBar: true,
    url: config.baseUrl + "profilesAround",
    beforeShow: function(){

        woofer.setActive(this.id);
    },
    afterShow: function(){

        woofer.setHeightKennel();
        var sequenceInSet = getParameterByName("sequenceInSet");
        console.log("sequence requested is " + sequenceInSet);


        state.alreadyProcessingSequence = true;

        // There is no sequence in the set already - probably first run after getting data loaded.

        if(!sequenceInSet || sequenceInSet == null){
            // Set up the liked array and not liked array
            console.log("Looking for local profiles.");
            //filter out all local profiles to only those not liked/disliked.
            if(dataCache.profilesNearby){
                dataCache.unvotedProfilesNearby = _.filter(dataCache.profilesNearby, function(prof){
                    for(var i = 0; i < dataCache.LikesByMe.length;i++){
                        if(dataCache.LikesByMe[i].attributes.receiverId == prof.id){
                            return false;
                        }
                    }
                    return true;
                });

                //this is all profiles the user voted no to.
                dataCache.unlikedProfilesNearby = _.filter(dataCache.profilesNearby, function(prof){
                    for(var i = 0; i < dataCache.LikesByMe.length;i++){
                        if(dataCache.LikesByMe[i].attributes.sentiment == true && dataCache.LikesByMe[i].attributes.receiverId == prof.id){
                            return false;
                        }
                    }
                    // or hasnt voted for.
                    return true;
                });

                profileArrayUsing = dataCache.unvotedProfilesNearby;
            }

            // theres unliked, so load that straight up.
            if(dataCache.unvotedProfilesNearby && dataCache.unvotedProfilesNearby.length > 0){
                console.log("There is local profiles.");
                state.alreadyProcessingSequence = false;
                woofer.loadSniffProfile(0);
            }
            else{
                // the only profiles are ones they've already seen, or no profiles at all.
                console.log("there is no local profiles that haven't been voted on.");
                if(dataCache.profilesNearby && dataCache.profilesNearby.length > 0){
                    // Reload card, and say we can use already sniffed. Use element zero.
                    if(sequenceInSet == null || sequenceInSet == 0){

                        woofer.showAlreadyLikedProfiles();
                        return false;
                    }
                }
                else{
                    if(dataCache.profilesNearby && dataCache.profilesNearby.length == 0){
                        // Problem.
                        swal('sorry no profiles nearby.');
                        state.alreadyProcessingSequence = false;
                        return false;
                    }
                    else{
                        //on first load.
                        if(!state.waitingForProfiles){
                            if(!dataCache.position){
                                woofer.tryGetLocation(parseAdapter.getProfilesNearby);
                            }
                            else{
                                parseAdapter.getProfilesNearby();
                            }

                            console.log("Wasnt waiting for profiles so kicked it off.");
                            var tpl = _.template($("#waitingForData").html());
                            var compiled = tpl({});
                            $(".profilesAround").append(compiled);
                        }else{

                        }
                        console.log("Quitting load because waiting for profiles or processing seq.");
                        var tpl = _.template($("#waitingForData").html());
                        var compiled = tpl({});
                        $(".profilesAround").append(compiled);
                        return false;
                    }
                }
            }
        }
        else{
            // we are go to load sequenceInSet from relevant array.
            if(getParameterByName("loadAlreadySniffed") == "true"){
                profileArrayUsing = dataCache.unlikedProfilesNearby;
            }
            if(profileArrayUsing.length == 0 && profileArrayUsing == dataCache.unvotedProfilesNearby && sequenceInSet == 0){
                // User has run out of profiles and is asking for 0 in set (probably going through liking)
                woofer.showAlreadyLikedProfiles();
                return false;
            }
            console.log(profileArrayUsing.length);
            if(profileArrayUsing.length == 0 && profileArrayUsing == dataCache.unlikedProfilesNearby && sequenceInSet == 0){
                // User has run out of profiles and is asking for 0 in set (probably going through liking)
                swal("","It looks like you've liked all the profiles we have available! Please check back again later.");
                if(profileArrayUsing.length > 0){
                    //run it through again if there's any disliked or not liked.
                    woofer.showAlreadyLikedProfiles();
                }
                else{
                    var tpl = _.template($("#waitingForData").html());
                    var compiled = tpl({});
                    $(".active_card").html("").append(compiled);

                    return false;
                }
            }
            console.log("Trying to load element " + sequenceInSet + " of " + profileArrayUsing.length);
            var profile = profileArrayUsing[sequenceInSet];

            // check this isn't a friend.
            var friend = _.find(dataCache.friends, function(f){
                return f.id == profile.id;
            });
            if(friend){
                woofer.loadSniffProfile(1);
            }

            if(profile.dog){
                var age = profile.dog.get("dateOfBirth");
                if(age){

                    var yo = moment(age).fromNow(true).replace("years","").trim();
                    if(yo.indexOf("months") > 0){
                        yo = 0;
                    }
                    profile.dog.age_yo = yo;
                    /*
                     age_field.attr('data-age', yo);
                     age_field.attr('data-dateOfBirth', moment(age).format("YYYY-MM-DD"));*/
                }
            }



            var tpl = _.template($("#sniffTemplate").html());
            $(".profilesAround").html("");
            dataCache.currentSniffProfile = profile;
            var coverPhoto = profile.dog.get("coverPhoto");
            dataCache.currentSniffProfile.activePhoto = coverPhoto;

            if(profile.dog.get(coverPhoto)) {
                profile.dog.coverPhoto =profile.dog.get(coverPhoto).url();
            }
            else{
                profile.dog.coverPhoto = "";
            }

            //preload all photos for swiping.
            try{preloadImage(profile.dog.get("photo").url());}catch(e){}
            try{preloadImage(profile.dog.get("photo2").url());}catch(e){}
            try{preloadImage(profile.dog.get("photo3").url());}catch(e){}
            try{preloadImage(profile.dog.get("photo4").url());}catch(e){}





            // add my like status.
            var like = _.find(dataCache.LikesByMe, function(l){
                var match = l.attributes.receiverId == profile.id;
                return match;
            });
            if(!like){
                like = {};
            }
            profile.like = like;

            // if(profile.dog.photo && profile.dog)
            var compiled = tpl({profile: profile, sequenceInSet: sequenceInSet});
            $(".profilesAround").append(compiled);

        }
        woofer.setHeightKennel();


        var sw = document.getElementById("swipe-area");
        var mc = new Hammer(sw);
        mc.on("swipeleft swiperight",function(ev){
            if(state.swiping == true){
                console.log("was already swiping");
                return;
            }
            state.swiping = true;
            if(ev.type == "swipeleft"){
                woofer.nextPhoto(1);
            }
            else{
                woofer.nextPhoto(-1);
            }
            window.setTimeout(function(){state.swiping = false;},200);
        });
        var hasSeenTip = false;
        if(Parse.User.current().attributes.hasSeenSwipeTip != undefined){
            hasSeenTip =Parse.User.current().attributes.hasSeenSwipeTip;
        }
        if(!hasSeenTip){
            swalevent=function(){

                window.swal_closeModal();
                window.setTimeout(function(){

                    swal("Hint #2...",  "Tap the 'Bone' to like a profile and 'Poo' to dislike a profile.");
                },500)
            };
            swal("Hint...",  "<img class='swipe-left' src='" + blankImage + "'><br>  Swipe to view different photos.");
            //Parse.User.current().attributes.hasSeenSwipeTip = true;
            Parse.User.current().set('hasSeenSwipeTip',true);
            Parse.User.current().save();
        }

        state.alreadyProcessingSequence = false;




    },
    events: function () {
        var pa = $(".profilesAround");
        $(".profilesAround").on(tap_event, ".bone",function(){
            $(".in-bowl").removeClass('active');
            $(this).addClass("active");
            var sniff_id = $("#sniff_id").val();
            window.setTimeout(function(){$(".in-bowl").removeClass("active");},300);
            parseAdapter.registerLike(sniff_id,true, function(){
                woofer.loadSniffProfile(1);
            });


        });
        $(".profilesAround").on(tap_event, ".pollywaffle",function(){
            $(".in-bowl").removeClass('active');
            $(this).addClass("active");
           var sniff_id = $("#sniff_id").val();
            window.setTimeout(function(){$(".in-bowl").removeClass("active");},300);
            parseAdapter.registerLike(sniff_id,false, function(){
                woofer.loadSniffProfile(1);
            });


        });
    }
});
cards.push({
    id: "friends",
    title: "Friends",
    showIconBar: true,
    url: config.baseUrl + "friends",
    beforeShow: function(){
        woofer.setActive(this.id);
    },
    afterShow: function(){

        woofer.setHeightKennel();
        var sequenceInSet = getParameterByName("sequenceInSet");
        console.log("sequence requested is " + sequenceInSet);
        $(".icon-bar-friends .badge").hide();
        if((state.waitingForProfiles == true || state.alreadyProcessingSequence == true) && !dataCache.friends){
            console.log("Quitting load because waiting for profiles or processing seq.");
            var tpl = _.template($("#waitingForData").html());
            var compiled = tpl({});
            $(".friendsList").html(compiled);
            return false;
        }
        else{
            woofer.enumerateFriends();


            if(dataCache.friends && dataCache.friends.length > 0) {
                // sort friends list by last communication in explicit friendship.
                // if no last comm, drop to bottom.
                dataCache.friends = _.sortBy(dataCache.friends, function (f) {
                    if (!f.explicit_friendship) {
                        return new moment().subtract(100, 'years');
                    }
                    return f.explicit_friendship.updatedAt;
                }).reverse();
            }

            //if friend ID has been specified, find that profile and reload.
            var specifiedId = getParameterByName("friendId");
            if(specifiedId){
                for(var i = 0; i < dataCache.friends.length; i++){
                    if(dataCache.friends[i].id == specifiedId){
                        loadCard("friends",{params:{sequenceInSet: i}});
                    }
                }
                return false;
            }
            var u = Parse.User.current();
            if(!u.attributes.lastViewedPack){
                u.fetch().then(function(){
                    u = Parse.User.current();
                    u.set('lastViewedPack' , new Date());
                    u.save();
                })
            }
            else{
                u.set('lastViewedPack' , new Date());
                u.save();
            }
            if(dataCache.friends && dataCache.friends.length > 0){

                state.alreadyProcessingSequence = true;
                if(!sequenceInSet || sequenceInSet == null){

                    sequenceInSet = 0;
                    loadCard("friends",{params:{sequenceInSet: sequenceInSet}});
                }
                if(sequenceInSet >= dataCache.friends.length){
                    sequenceInSet = 0;


                }
                if(sequenceInSet < 0){
                    sequenceInSet = dataCache.friends.length - 1;
                }
                woofer.loadFriend(sequenceInSet);

                var sw = document.getElementById("pack-swipe-area");
                var mc = new Hammer(sw);
                mc.on("swipeleft swiperight",function(ev){
                    if(state.swiping == true){
                        console.log("was already swiping");
                        return;
                    }
                    state.swiping = true;
                    sequenceInSet = parseInt(sequenceInSet);
                    if(ev.type == "swipeleft"){
                        sequenceInSet +=1;
                    }
                    else{
                        sequenceInSet -=1
                    }
                    if(sequenceInSet < 0){ sequenceInSet = dataCache.friends.length - 1;}
                    if(sequenceInSet >= dataCache.friends.length){ sequenceInSet = 0;}
                    loadCard("friends", {params: {sequenceInSet: sequenceInSet}});

                    window.setTimeout(function(){state.swiping = false;},200);
                    return false;
                });


                woofer.setHeightKennel();
                if($(".friendsList .dogname .name").prop('scrollWidth') > $(".friendsList .dogname .name").width() ||
                    $(".friendsList .dogname .name").height() > 45){
                    $(".friendsList .dogname .name").css({fontSize:"12pt"});

                }
                state.alreadyProcessingSequence = false;
            }
            else{
                if(state.waitingForProfiles){
                    // alert("waiting for profiles.");
                }
                else{
                    swal("Hint..","When you have made friends through woofer they will appear here.");
                }

            }


        }


    },
    events: function () {
        $("body").on(tap_event,'.newspaper-bark',function(){
            var friendId = $("#currentFriendId").text();
            loadCard("messaging", {params: {conversationRecipient: friendId}});
        });
        $("body").on(tap_event,".poo-unfriend", function(){
            var friendId = $("#currentFriendId").text();
            swal({title: "Unfriend, Are you sure?", text: "<button class='woofer yes-unfriend'>Yes, unfriend!</button><br /><button class='woofer nevermind'>No, nevermind</button>", showConfirmButton: false });

        });

        $("body").on('click','.nevermind',function(){
                window.swal_closeModal();
            }
        );

        $("body").on('click','.nevermind-open-park',function(){
            var parkId = $(this).attr('data-park-exists-id');
            loadCard("parkDetails", {params: {parkId: parkId}});
            window.swal_closeModal();
        });

        $("body").on('click', '.yes-unfriend', function(){
            var myId = Parse.User.current().id;
            var friendId = $("#currentFriendId").text();

            woofer.unfriend(myId, friendId);
            window.swal_closeModal();

        });
    }
});
cards.push({
    id: "findAPark",
    title: "Find A Park",
    showIconBar: true,
    url: config.baseUrl + "findAPark",
    beforeShow: function () {
        woofer.setActive(this.id);


    },
    afterShow: function () {

        var now = new Date().getTime();
        var lastChecked = 0;
        if (locationObj != null) lastChecked = locationObj.Timestamp;

        //60s * 5 minutes.
        if (lastChecked < now - 1000 * 60 * 5) {
            woofer.tryGetLocation(function (position) {
                parseAdapter.getParksNearby(position.coords.latitude, position.coords.longitude);
            });
        }



        var position = dataCache.position;
        if(!position){
            window.setTimeout(function(){
                if(!dataCache.looksLikeLocationDisabled){
                    if(state.cardId == "findAPark") loadCard("findAPark");
                }
            }, 1000);
            return;
        }
        if(position){
        var mapOptions = {
            center: {lat: position.coords.latitude, lng: position.coords.longitude},
            zoom: 14,
            disableDefaultUI: true
        };
        map = new google.maps.Map(document.getElementById("map_canvas"), mapOptions);
        }

        if(dataCache.parksNearby){
            console.log("There are " + dataCache.parksNearby.length + "parks nearby.");
            _.each(dataCache.parksNearby, function(park){
                woofer.loadPinForPark(park, map, park.attributes.isVerified == true ? "verified" : "notVerified");

            });
        }
        else{
            window.setTimeout(function(){
                if(getParameterByName("card") == "findAPark"){
                if(!dataCache.looksLikeLocationDisabled){

                    loadCard("findAPark");
                }
                }
            }, 1000);
            return;
        }



    },
    events: function () {

        $(".findAPark-select-park-nearby").on(tap_event, function () {
            var park_id = $(this).attr('data-park-id');
            loadCard("parkDetails", {params: {parkId: park_id}});
        });
    }
});
cards.push({
    id: "parkDetails",
    title: "Park Details",
    showIconBar: false,
    url: config.baseUrl + "parkDetails",
    beforeShow: function () {
        $("#park-recent-visitors").html("");
    },
    afterShow: function(){
        var id = getParameterByName("parkId");
        if(id == null){
            loadCard("findAPark");
            return false;
        }
        var park = _.find(dataCache.parksNearby, function (park) {
            return park.id == id;
        });
        $(".addAPark .add-park-name").text("Park Name").removeClass("name-chosen");
        $(".add-on-leash-times").text("Add Times").removeClass("name-chosen");
        $("#park-name").text(park.attributes.Name);
        var olt = $("#on-leash-times");
        olt.text("(None Specified)");
        if(park.attributes.OnLeashBetween != ""){
            olt.text(park.attributes.OnLeashBetween);
        }
        $(".park-address").html(
            (park.attributes.Address +"<br/>" +
            (park.attributes.Suburb ? park.attributes.Suburb : "") + " " +
            ( park.attributes.State ? park.attributes.State : "") + " " +
            (park.attributes.Postcode ? park.attributes.Postcode : "")).toUpperCase()
        );
        $(".park-icon").removeClass("false");
        if(park.attributes.Fenced == false){
            $(".parkfenced").addClass("false");
        }
        if(park.attributes.PooBags == false){
            $(".parkbags").addClass("false");
        }
        var parkpos = park.attributes.Location;
        if(parkpos){

            var mapOptions = {
                center: {lat:parkpos.latitude, lng: parkpos.longitude},
                zoom: 14,
                disableDefaultUI: true
            };
            map2 = new google.maps.Map(document.getElementById("map_canvas2"), mapOptions);
            woofer.loadPinForPark(park, map2, park.attributes.isVerified == true ? "verified" : "notVerified");
        }

        //TODO: The callback needs to populate the doggie images.
        parseAdapter.getRecentVisitorsToPark(park, function(visitors){
            woofer.loadRecentVisitorsToPark(park);

        });
    },
    events: function () {
        $("#leavePawPrint").on(tap_event, function(){
            var park = _.find(dataCache.parksNearby, function(park){
                return park.id == getParameterByName("parkId");
            });
            parseAdapter.leavePawPrintAtPark(park)
        })
    }
});
cards.push({
    id: "addAPark",
    title: "Add A Park",
    showIconBar: true,
    url: config.baseUrl + "addAPark",
    beforeShow: null,
    afterShow: function(){
        if(!dataCache.position || !google || !google.maps || !google.maps.Map){
            loadCard("addAParkLoading");
            return false;
        }
        if(geocoder == null){

            geocoder = new google.maps.Geocoder();
        }
        var mapOptions = {
            center: {lat:dataCache.position.coords.latitude, lng: dataCache.position.coords.longitude},
            zoom: 17,
            disableDefaultUI: true
        };
        map3 = new google.maps.Map(document.getElementById("map_canvas3"), mapOptions);
        woofer.loadPinForLatLng(dataCache.position.coords.latitude, dataCache.position.coords.longitude, map3, "notVerified");
        $("#add-park-latitude").val(dataCache.position.coords.latitude);
        $("#add-park-longitude").val(dataCache.position.coords.longitude);
        var latlng = new google.maps.LatLng(dataCache.position.coords.latitude, dataCache.position.coords.longitude);
        geocoder.geocode({'latLng': latlng}, function(results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                if (results[1]) {
                    var add = results[1].formatted_address;
                    if(add.substr(add.length - 11, 11) == ", Australia"){
                        add = add.substr(0, add.length - 11);
                    }
                    $(".addAPark .park-address").text(add);
                }
            }
        });

        var hasSeenNominateTip = false;
        if(Parse.User.current().attributes.hasSeenNominateTip != undefined){
            hasSeenNominateTip =Parse.User.current().attributes.hasSeenNominateTip;
        }
        if(!hasSeenNominateTip){

                swalevent=function(){

                    window.swal_closeModal();
                    window.setTimeout(function(){

                        swal("Hint #2...",  "Tap the fence and dog poo bag to mark if the park is fenced and has waste bags available.");
                    },500)
                };
                swal("Hint...",  "<img class='img-tap' src='" + blankImage + "'><br> Does the park have on-leash times? Tap Add leash times' to enter.<br> Tap 'Add Park Name' to set the name of the park.");
                //Parse.User.current().attributes.hasSeenSwipeTip = true;
                Parse.User.current().set('hasSeenNominateTip',true);
                Parse.User.current().save();
        }

    },
    events: function () {
        $(".addAPark .parkfenced, .addAPark .parkbags").on(tap_event,function(){
            var on = !$(this).hasClass("false");
            if(on){
                $(this).addClass("false");
            }
            else{
                $(this).removeClass("false");
            }
        });

        $(".add-park-name").on(tap_event,function(){
            var editNameContents = $("#editParkNameTemplate");
            var existing_name = $(".addAPark .park-name").text().trim();
            swalevent = function(){


                var swal_box = $(".sweet-alert");

                $(".addAPark .add-park-name").text(swal_box.find(".enter_park_name").val()).addClass("name-chosen");
            };
            swal("Park Name:", editNameContents.html());
            $(".sweet-alert").find(".enter_park_name").val(existing_name);

        });
        $("body").on('keydown','.sweet-alert .enter_park_name', function(){
            var l = $(this).val().length;
            if(l > 30){
                return false;
            }
        });
        $(".add-on-leash-times").on(tap_event,function(){
           var editLeashContents = $("#editParkHoursTemplate");
            swalevent = function(){

                var swal_box = $(".sweet-alert");

                $(".addAPark .on-leash-times").text(
                    swal_box.find(".enter_park_leash_start").val() + " - " +
                    swal_box.find(".enter_park_leash_end").val()
                );

                $(".add-on-leash-times").text( swal_box.find(".enter_park_leash_start").val() + " - " +
                swal_box.find(".enter_park_leash_end").val()).addClass("name-chosen");

            };
            swal("On-Leash Times:", editLeashContents.html());
        });
        $("#addPark").on(tap_event,function(){
           var park_name = $(".addAPark .add-park-name").text();
            var park_address = $(".addAPark .park-address").text();
            var position =  new Parse.GeoPoint({latitude: parseFloat($("#add-park-latitude").val()), longitude: parseFloat($("#add-park-longitude").val())});
            var fenced = !$(".addAPark .parkfenced").hasClass("false");
            var poobags = !$(".addAPark .parkbags").hasClass("false");
            var leashtimes = $(".on-leash-times").text();

            var ParkObj = Parse.Object.extend("Park");
            var park = new ParkObj();
            park.set("Name", park_name);
            park.set("Address", park_address);
            park.set("Location", position);
            park.set("Fenced", fenced);
            park.set("PooBags", poobags);
            park.set("isVerified", false);
            park.visitors = [];
            if(leashtimes != ""){
                park.set("OnLeashBetween", leashtimes);
            }
        parseAdapter.saveNewPark(park, function(park){
            var aap = $(".addAPark");
            aap.find(".on-leash-times").text("");
            aap.find(".park-icon").removeClass("false");
            aap.find(".park-name").html("&nbsp;");
            aap.find(".park-address").text("");
            $(".add-park-name").show();
            $(".add-on-leash-times").show();
            swalevent = function(){
                history.replaceState(null, "Add Park", config.baseUrl + "addAPark");
                loadCard("parkDetails", {params:{parkId: park.id}});
            }
            swal("Saved!", "Your new park has been saved for verification.");
        });




        });
    }
});
cards.push({
    id: "addAParkLoading",
    title: "Add A Park",
    showIconBar: true,
    url: config.baseUrl + "addAParkLoading",
    beforeShow: null,
    afterShow: function(){

        window.setTimeout(function(){
            if(!dataCache.position){
                woofer.tryGetLocation(function(){
                    loadCard("addAPark");
                    return false;
                });
            }
            if(google && google.maps && google.maps.Map && dataCache.position && getParameterByName("card") == "addAParkLoading"){
                loadCard("addAPark");
                return false;
            }
        },1000)
    },
    events: function () {

    }
});
cards.push({
    id: "messages",
    title: "Messages",
    showIconBar: true,
    url: config.baseUrl + "messages",
    beforeShow: function(){
        woofer.enumerateFriends();
        woofer.setActive(this.id);

    },
    afterShow: function(args){

        console.log("Request likes to me (just in case..");
        if(args && args.params){
            if(args.params.cameFromReloadingMessages == true){

            }
            else{
                woofer.enumerateFriends();
            }
        }
        else{
            woofer.enumerateFriends();
        }
    parseAdapter.getExplicitFriends();

        if((state.waitingForProfiles == true || state.alreadyProcessingSequence == true) && !dataCache.friends){
            console.log("Quitting load because waiting for profiles or processing seq.");
            var tpl = _.template($("#waitingForData").html());
            var compiled = tpl({});
            $(".messages").html(compiled);
            return false;
        }
        else{
            var friends = [];
            if(dataCache.friends){
                friends = dataCache.friends;
            }
            if(friends.length == 0){
                swal("Hint...","When you have made friends through woofer, you can chat with them here!");
                return;
            }
            var u = Parse.User.current();
            if(!u.attributes.lastViewedBark){
                u.fetch().then(function(){
                    u = Parse.User.current();
                    u.set('lastViewedBark' , new Date());
                    u.save();
                })
            }
            else{
                u.set('lastViewedBark' , new Date());
                u.save();
            }

            // for each friend, calculate their distance away.
            _.each(friends, function(friend){
                friend.distance_away_km = ""
                var position = friend.attributes.location;
                if(dataCache.position && dataCache.position.coords && position) {
                    var distance_away = distanceBetween(dataCache.position.coords.latitude, dataCache.position.coords.longitude, position.latitude, position.longitude);
                    if(distance_away > 0 && distance_away < 1){
                        friend.distance_away_km = "< 1km";
                    }
                    else{
                        friend.distance_away_km = Math.round(distance_away) + "km";
                    }

                }
            });

            friends = _.sortBy(friends, function(f){
                if(!f.explicit_friendship){
                    return new moment().subtract(100,'years');
                }
                return f.explicit_friendship.updatedAt;
            }).reverse();


            var tpl = _.template($("#messagesTemplate").html());
            var compiled = tpl({f: friends});
            $(".messages").html("");
            $(".messages").html(compiled);
            woofer.setHeightKennel();
            if(state.alreadyPolling){
                $(".friend-wrapper").scrollTop(dataCache.scrollPos);
                dataCache.scrollPos = null;
                state.alreadyPolling = false;
            }
        }
    },
    events: function () {
        $("body").on(tap_event, '.openConversation',function(){
            var dog_id = $(this).attr('data-dog-id');
            loadCard("messaging", {params:{conversationRecipient: dog_id}});
        });
    }
});
cards.push({
    id: "messaging",
    title: "Messaging",
    showIconBar: false,
    url: config.baseUrl + "messaging",
    beforeShow: function(){
        woofer.setActive(this.id);

    },
    afterShow: function(){
        var u = Parse.User.current();
        if(!u.attributes.lastViewedBark){
            u.fetch().then(function(){
                u = Parse.User.current();
                u.set('lastViewedBark' , new Date());
                u.save();
            })
        }
        else{
            u.set('lastViewedBark' , new Date());
            u.save();
        }



        // get conversation ID.
        var conversationRecipient = getParameterByName("conversationRecipient");
        if(conversationRecipient == null){
            loadCard("messages");
            return false;
        }


        var theirProfile = _.find(dataCache.friends,function(f){return f.id == conversationRecipient});


        // update this friendship, reset unread messages badge.
        var explicitFriend = _.find(dataCache.explicitFriends, function(f){
            return f.attributes.friend2 == conversationRecipient;

        });


        if(explicitFriend){
            explicitFriend.set('friend1unread',0);
            explicitFriend.save();
        }

        if(state.loadingConversation && state.loadingConversation == conversationRecipient){
            // already loading this conversation, be patient :)
            return false;
        }

        var conversationContents = _.find(dataCache.conversations, function(conv){
            return conv.id == conversationRecipient;
        });

        if(conversationContents != null){
            // if its been loaded show it and poll for more.
            var tpl = _.template($("#messagingTemplate").html());
            var messageTemplate = _.template($("#messageTemplate").html());
            conversationContents.conv = _.sortBy(conversationContents.conv, function(obj){return obj.createdAt});
            var compiled = tpl({conv: conversationContents.conv, dog: theirProfile.dog, messageTemplate: messageTemplate});
            $(".messaging").html("");
            $(".messaging").html(compiled);

            //check scroll widths.
            if($(".messaging .dogname .name").prop('scrollWidth') > $(".messaging .dogname .name").width() ||
                $(".messaging .dogname .name").height() > 45){
                $(".messaging .dogname .name").css({fontSize:"12pt"});

            }

            parseAdapter.pollAndAddNewMessages();

            woofer.setHeightKennel();

            var mydiv = $(".messaging").find(".chat-contents");
            mydiv.scrollTop(10000);
        }
        else{
            // if it hasn't, show waiting, load it, and the loaded event will reload.

            parseAdapter.loadConversation(conversationRecipient);
            console.log("Quitting load because waiting for conversation.");
            var tpl = _.template($("#waitingForData").html());
            var compiled = tpl({});
            $(".messaging").html(compiled);

            return false;
        }
    },
    events: function () {
        $("body").on(tap_event, '.messaging .dogname .name',function(){
            var dog_id = getParameterByName("conversationRecipient");
            loadCard("friends",{params: {friendId: dog_id}});
        });
        $("body").on(tap_event, '.bark',function(){
            // send this up as a conversation item, and add to window.
            var txt = $(".new_message").val();
            if(txt == ""){
                return;
            }
            var conversationRecipient = getParameterByName("conversationRecipient");
            var messageTemplate = _.template($("#messageTemplate").html());


            parseAdapter.addToConversation(txt,conversationRecipient, function(msg, error){

                var compiled = messageTemplate({msg: msg});
                $(".chat-contents").append(compiled);
                $(".new_message").val("");
                $(".no_messages").hide();
                //there was a new message.
                var mydiv = $(".messaging").find(".chat-contents");
                mydiv.scrollTop(10000);
            });



            // trigger a push notification for other guy.
        });
    }
});