var state = {cardId: null, vars: [], canSaveProfile: false, reloadingMessages: false, swiping:false};
var havePopped = false;
var onDeviceReadyHasFired = false;
var config = {
    baseUrl: "http://www.woofer.dev/index.html?card=",
    initCardId: "login"};
var cards = [];
var cardLoaded = null;
var enableClick = true;
var cardLoadedCallback = function(){
    var active_card = $(".active_card").children().first();
    if(active_card.hasClass("has-top-logo")){
        $("body").addClass("top-logo");
    }
    else{
        $("body").removeClass("top-logo");
    }
};
var preloadQueue = [];



window.onpopstate = function (event) {
    if(onDeviceReadyHasFired){
        runPopState(event);
    }
    else{
        var bootInterval = window.setInterval(function(){
            console.log("Checking for odr..");
            if(onDeviceReadyHasFired){
                console.log("odr has fired.");
                window.clearInterval(bootInterval);
                runPopState(event);
            }

        },500);
    }

};

// runs only once ondeviceready received.
function runPopState(event){
    console.log("is pop state for card " + getParameterByName("card"));


    if(window.parsePlugin && !installationID){
        window.parsePlugin.initialize(parseConfigApplicationKey, parseConfigClientKey, function() {
            console.log('success with key ' + parseConfigApplicationKey + ' and client key ' + parseConfigClientKey);

            window.parsePlugin.getInstallationId(function(id) {
                installationID = id;
                parseAdapter.resetBadgeToZero(installationID);
                console.log("installation id is " + id);
                parseAdapter.subscribe("aadevice");

            }, function(e) {
            });

        }, function(e) {
            console.log('error');
        });
    }
    else{
        console.log("PARSE PLUGIN DOESNT EXIST.");
    }




    if (event.state) {
        // is a stored page popping
        loadState(event.state);
        parseAdapter.resetBadgeToZero(installationID);
    } else {
        // triggered by a page load
        parseAdapter.resetBadgeToZero(installationID);
        var cardId = getParameterByName("card");
        if(cardId){
            //does the URL specify a particular card? (ie user went straight to URL)
            loadCard(cardId);
        }
        else{
            //run init - show home card.
            $("#debug").text("first load");
            init();
        }

    }
}
function loadState(eventState){

    loadCard(eventState.cardId, {isReload: true});
}
function getCardById(id){
    var card = null;
    card = _.find(cards, function(e){return e.id == id});
    return card;
}

///Possible args:
/*
isReload - is a reload of page.
params - key value parameters.
initial - replaces windowstate with this one.


 */
function loadCard(id, args){
    window.scrollTo(0,0);
    $(".icon-bar").children().removeClass("active");

    console.log("Loading " + id);
    var card = null;
    if(args == null) args = {};

    //if object was passed in, trust it is a card, otherwise find the card.
    if(typeof(id) !== "object"){
        card = getCardById(id);
    }
    else{
        card = id;
    }
    //store this id as the state - ie this card is showing
    state.cardId = card.id;
    cardLoaded = card;

    //clone the card so I can add any args as URL parameters (the card init's use URL params)
    var cardClone = jQuery.extend(true, {}, card);
    if(args && args.isReload){
        //If this is a card reloading, args will be empty. Use the URL params as is.
        cardClone.url = window.location.href;
    }
    else{
        //add any args.params as URL params.
        if(args && args.params){
            //add parameters to URL.
            _.each(args.params, function(e,i){
                cardClone.url += "&" + i + "=" + e;
                //save key and value pairs of url here - they get used in the init funcitons.
            })
        }
    }

    //show icon bar if relevant for this screen.
    if(cardClone.showIconBar && cardClone.showIconBar == true){
        $(".icon-bar").show();
    }
    else{
        $(".icon-bar").hide();
    }

    if(cardClone.beforeShow && typeof(cardClone.beforeShow == "function")){
        var result = cardClone.beforeShow(args); //might pull vars from URL etc.
        if(result === false){
            return;
        }
    }

    if(args && args.initial == true){
        //if its a first load, just replace this history with this card.
        history.replaceState(state,cardClone.title,cardClone.url);
    }
    else{
        //otherwise make it a history item.
        if(args && !args.isReload && document.URL != cardClone.url) {
            console.log("Pushing " + cardClone.title + " to stack");
                history.pushState(state,cardClone.title,cardClone.url);
        }
    }
    $("#debug").text("loaded " + cardClone.title);

    //if this card has an init function, call it. The init function should use URL params to work out what to do.


    //show the card.
    $(".cards").append($(".active_card").children());
    $(".active_card").append($(".card[data-card-id=" + cardClone.id + "]"));
    if(cardClone.afterShow && typeof(cardClone.afterShow == "function")){
        cardClone.afterShow(args); //might pull vars from URL etc.
    }
    cardLoadedCallback();

}
function init(){
     loadCard(config.initCardId, {initial:true});
}