var parseAdapter = {};
parseAdapter = {
    tryRegister: function (firstName, lastName, email, password, callback) {
        var retval = new Retval();
        if (!firstName || firstName.trim() == "") {
            retval.success = false;
            retval.validationMessages.push("Enter a first name.");
            retval.failedFields.push("#register-first-name");
        }
        if (!lastName || lastName.trim() == "") {
            retval.success = false;
            retval.validationMessages.push("Enter a last name.");
            retval.failedFields.push("#register-last-name");
        }
        if (!email || email.trim() == "") {
            retval.success = false;
            retval.validationMessages.push("Enter an email address.");
            retval.failedFields.push("#register-email");
        }
        else {
            if (!validateEmail(email)) {
                retval.success = false;
                retval.validationMessages.push("Enter a valid email address.");
                retval.failedFields.push("#register-email");
            }
        }
        if (!password || password.trim() == "") {
            retval.success = false;
            retval.validationMessages.push("Enter a password.");
            retval.failedFields.push("#register-password");
        }
        if (retval.success == false) {
            callback(retval);
        }
        if (retval.success == true) {
            // All looks OK, create account in Parse.
            email = email.toLowerCase();
            var user = new Parse.User();
            user.set("username", email);
            user.set("email", email);
            user.set("password", password);
            user.set("firstName", firstName);
            user.set("lastName", lastName);

            user.signUp(null, {
                success: function (user) {
                    logged_in_user = user;
                    retval.success = true;
                    parseAdapter.tryGetProfile();



                    var notification_id = "";
                    if(user.attributes.notification_id == "" || typeof(user.attributes.notification_id) == "undefined"){
                        notification_id = makeid();
                        user.set("notification_id", notification_id);
                        user.save();
                        parseAdapter.subscribe("n_" + notification_id);


                    }
                    else{
                        notification_id = user.attributes.notification_id;
                    }



                    callback(retval);
                },
                error: function (user, error) {
                    retval.success = false;
                    retval.validationMessages.push(error.message);
                    callback(retval);
                }
            });
        }


    },
    tryLogin: function (username, password, callback) {
        var retval = new Retval();
        if (!username || username.trim() == "") {
            retval.success = false;
            retval.validationMessages.push("Enter an email.");
            retval.failedFields.push("#login-username");
        }
        if (!password || password.trim() == "") {
            retval.success = false;
            retval.validationMessages.push("Enter a password.");
            retval.failedFields.push("#login-password");
        }
        if (retval.success == false) {
            callback(retval);
        }
        if (retval.success == true) {
            // All looks OK, attempt login.
            username = username.toLowerCase().trim();
            password = password.trim();
            Parse.User.logIn(username, password, {
                success: function (user) {
                    dataCache.friends = null;
                    dataCache.profile = null;
                    logged_in_user = user;
                    retval.success = true;
                    if (dataCache.Position) {
                        user.set("location", new Parse.GeoPoint({
                            latitude: dataCache.Position.coords.latitude,
                            longitude: dataCache.Position.coords.longitude
                        }));

                    }
                    else {
                        console.log("Datacache position was empty.");
                    }
                    var notification_id = makeid();
                    user.set("notification_id", notification_id);
                    user.save();
                    parseAdapter.getChannels(function (channels) {
                        if (typeof(channels) != "object") {
                            channels = channels.replace("[", "").replace("]", "").split(",");
                        }
                        for (var i = 0; i < channels.length; i++) {
                            channels[i] = channels[i].trim();
                            if (channels[i].substr(0, 7) == "chan_n_") {
                                parseAdapter.unsubscribe(channels[i]);
                            }
                        }
                        parseAdapter.subscribe("n_" + notification_id);



                    });

                    if (user.attributes.hasNewFriendList !== true) {

                        parseAdapter.createExplicitFriendsFromOldFormat();
                    }


                    parseAdapter.getExplicitFriends(); // loads friends from the friends table into datacache.friends.


                    parseAdapter.tryGetProfile();


                    var user = Parse.User.current();
                    user.fetch().then(function () {
                        user = Parse.User.current();
                        var messagesCallback = woofer.displayMessagesBadge;
                        var friendsCallback = woofer.displayFriendsBadge;
                        parseAdapter.getActivitySince(messagesCallback, friendsCallback);

                        if (user.attributes.notification_id == "" || typeof(user.attributes.notification_id) == "undefined") {
                            var notification_id = makeid();
                            user.set("notification_id", notification_id);
                            user.save();
                            parseAdapter.subscribe("n_" + notification_id);
                        }
                    });

                    callback(retval);
                },
                error: function (user, error) {
                    retval.success = false;
                    retval.validationMessages.push(error.message);
                    callback(retval);
                }
            });

        }
    },
    registerLike: function (receiverId, sentiment, then) {

        var Like = Parse.Object.extend("Likes");
        //delete any existing likes that match these conditions.
        var query = new Parse.Query(Like);
        query.equalTo("senderId", Parse.User.current().id);
        query.equalTo("receiverId", receiverId);
        query.find({
            success: function (results) {
                for (var i = 0; i < results.length; i++) {
                    var object = results[i];
                    object.destroy();
                }

                var like = new Like();
                like.set("senderId", Parse.User.current().id);
                like.set("receiverId", receiverId);
                like.set("sentiment", sentiment);
                like.save();
                var existing_like = _.find(dataCache.LikesByMe, function (l) {
                    var match = (l.attributes.receiverId == receiverId);
                    return match;
                });
                //if already in array (e.g. a like becomes a dislike) dump the old one.
                dataCache.LikesByMe = _.reject(dataCache.LikesByMe, function (lbm) {
                    return (lbm.attributes.receiverId == receiverId);
                });
                dataCache.LikesByMe.push(like);
                console.log("New Like saved.");

                //now there is a like, cut this profile out of the set if we are in 'unliked' array.

                var seq = getParameterByName("sequenceInSet");


                var likedProfile = _.find(dataCache.profilesNearby, function (prof) {
                    return prof.id == receiverId;
                });

                dataCache.likedProfiles.push(likedProfile);

                //if(profileArrayUsing == dataCache.unvotedProfilesNearby){
                // slice this profile out of the set now that it's been liked.
                if (seq > -1 && sentiment == true) {
                    profileArrayUsing.splice(seq, 1);
                }
                //}


                // does the receiver like me too?

                // If so, trigger an alert for me, and an alert for receiver.
                var heLikesMe = function () {
                    //was this already liked?

                    if (!existing_like) {
                        swal("That dog likes you too!", "You are now friends - tap the 'my pack' tab to see their profile or start a conversation");


                        var theirProfile = _.find(dataCache.likedProfiles, function (f) {
                            return f.id == receiverId
                        });

                        var notification_channel_id = "chan_" + receiverId;

                        if (theirProfile) {
                            // try and get the notification channel for their current device.
                            if (theirProfile.attributes.notification_id != "") {
                                notification_channel_id = "chan_n_" + theirProfile.attributes.notification_id;
                            }
                        }

                        // create a new friend record.
                        var friendObject = Parse.Object.extend("Friends");
                        var friend = new friendObject();
                        friend.set("friend1", receiverId);
                        friend.set("friend2", Parse.User.current().id);
                        friend.save();
                        var friend = new friendObject();
                        friend.set("friend1", Parse.User.current().id);
                        friend.set("friend2", receiverId);
                        friend.save();

                        Parse.Push.send({
                            channels: [notification_channel_id],
                            data: {alert: "You have a new friend! Check your pack to say hi!", badge: "Increment"}
                        });

                        //get this profile and put it in the dataCache.likedProfiles array.

                        woofer.enumerateFriends();
                    }


                };
                var heDoesntLikeMe = function () {
                    // he doesnt like me..
                    // load next card then.
                    /* var loadAlreadySniffed = getParameterByName("loadAlreadySniffed");
                     loadCard("profilesAround", {params: {sequenceInSet: seq, loadAlreadySniffed: loadAlreadySniffed}});*/
                };
                if (sentiment == true) {
                    parseAdapter.checkIfHeLikesMe(Parse.User.current().id, receiverId, heLikesMe, heDoesntLikeMe);
                    parseAdapter.getLikesToMe();
                }
                woofer.enumerateFriends();
                if (typeof(then) == "function") {
                    then();
                }
            }
        });

    },
    checkIfHeLikesMe: function (possibleReceiver, possibleSender, doesLikeCallback, doesntLikeCallback) {
        // check if possibleSender likes possibleReceiver.
        var Like = Parse.Object.extend("Likes");
        var qReceiver = new Parse.Query(Like);
        qReceiver.equalTo("receiverId", possibleReceiver);
        qReceiver.equalTo("senderId", possibleSender);
        qReceiver.find({
            success: function (results) {
                if (results.length > 0) {
                    //cool, reciprocated.
                    if (results[0].attributes.sentiment == true) {
                        if (doesLikeCallback != null) {
                            doesLikeCallback();
                        }
                    }
                    else {
                        console.log("possible sender doesnt like this receiver!");
                        if (doesntLikeCallback != null) {
                            doesntLikeCallback();
                        }
                    }
                }
                else {
                    if (doesntLikeCallback != null) {
                        doesntLikeCallback();
                    }
                }
            }
        });
    },
    getActivitySince: function (messagesCallback, friendsCallback) {
        var u = Parse.User.current();
        // chats since

        /*if(u.attributes.lastViewedBark){
         var ConvMsgObj = Parse.Object.extend("ConversationMessages");

         var qMessages = new Parse.Query(ConvMsgObj);
         qMessages.equalTo("toUserId", Parse.User.current().id);
         qMessages.greaterThan( "updatedAt", u.attributes.lastViewedBark );
         qMessages.count({
         success: function(count){
         count_chats = count;
         messagesCallback(count);
         }
         });
         }*/

        // get count of badges where I am friend 1 in explicit friends.
        if (messagesCallback) {
            var outstandingBadges = 0;
            if (dataCache.explicitFriends) {

                //dataCache.explicitFriends = _.uniq(dataCache.explicitFriends, false, 'friend2');
                _.each(dataCache.explicitFriends, function (f) {
                    if (f.attributes.friend1unread) {
                        outstandingBadges += f.attributes.friend1unread;

                    }
                });
                messagesCallback(outstandingBadges);
            }
        }


        if (friendsCallback) {
            if (u.attributes.lastViewedPack) {
                var FriendObj = Parse.Object.extend("Friends");
                var qFriends = new Parse.Query(FriendObj);
                qFriends.equalTo("friend1", Parse.User.current().id);
                qFriends.greaterThan("createdAt", u.attributes.lastViewedPack);
                qFriends.count({
                    success: function (count) {
                        friendsCallback(count);
                    }
                });
            }
        }


    },
    saveLocation: function (position) {
        console.log("Saving position against user.");
        var point = new Parse.GeoPoint({latitude: position.coords.latitude, longitude: position.coords.longitude});
        var u = Parse.User.current();
        if (u) {
            u.set("location", point);
            try {
                console.log("saving..");
                u.save(null, {
                    success: function (user) {
                        console.log("positino save success!");
                    },
                    error: function (user, e) {
                        if (e.code == 101) {
                            loadCard("login", {params: {force: true}});
                        }
                    }
                });
            }
            catch (err) {
                console.log(err);
            }
            // if this guy has a profile, save it under the profile too.

        }
        else {
            dataCache.Position = position;
            console.log("u was invalid.");
        }
    },
    tryGetBreeds: function () {
        var Breed = Parse.Object.extend("Breed");
        var breedQ = new Parse.Query(Breed);
        breedQ.limit(250);
        breedQ.addAscending('breedName');
        breedQ.find({
            success: function (breeds) {
                dataCache.breeds = breeds;
                woofer.loadBreeds();
            }
        });
    },

    resetBadgeToZero: function (installationId) {

        var parseConfigApplicationKey = "AvRALvUyHGoUfqnv1bDgwNTqhOc0SghcrK5B94Xk";
        var parseConfigJavascriptKey = "SzcFiQWHABEhpqYslBQBDuIU9pD8Jv4ppRKMFvn2";
        var parseConfigRestKey = "kZOcYpolCeXrCkeOoDTGgD18n7osoSPH9PqW73Jm";
        var parseConfigClientKey = "diwbnpei1cvmA6DPb0sCG4OV4Qfh2yh7KKd1AXSR";


        //curl -X PUT -H "X-Parse-Application-Id: AvRALvUyHGoUfqnv1bDgwNTqhOc0SghcrK5B94Xk" -H "X-Parse-REST-API-Key: kZOcYpolCeXrCkeOoDTGgD18n7osoSPH9PqW73Jm" -H "Content-Type: application/json" -d '{"badge": 0}' https://api.parse.com/1/installations/tZOOu5B7LC

        Parse.Cloud.run("resetBadgeForInstallation", {
            installationId: installationId
        }, {success: function(){

        }, error: function(e){

        }});
    },

    leavePawPrintAtPark: function (park, callback) {
        var parkId = park.id;
        var ParkCheckinObj = Parse.Object.extend("ParkCheckin");

        // make sure this guy hasn't already checked in at this park.
        var existing = _.find(park.visitors, function (v) {
            return v.attributes["userId"] == Parse.User.current().id;
        });
        if (existing) return;

        var CheckIn = new ParkCheckinObj();
        CheckIn.set("userId", Parse.User.current().id);
        CheckIn.set("parkId", parkId);
        CheckIn.save(null, {
            success: function (checkin) {
                checkin.profile = dataCache.profile;
                park.visitors.push(checkin);
                var cic = park.attributes.checkinsCount;
                if (isNaN(cic)) {
                    cic = 0;
                }
                cic += 1;
                park.set("checkinsCount", cic);
                if (park.attributes.checkinsCount >= 2) {
                    park.set("isVerified", true);
                }
                park.save();
                woofer.loadRecentVisitorsToPark(park, loadCard("parkDetails", {params: {parkId: parkId}}));
            }
        });
    },

    getRecentVisitorsToPark: function (park, callback) {
        var parkId = park.id;
        var ParkCheckinObj = Parse.Object.extend("ParkCheckin");
        var qCheckins = new Parse.Query(ParkCheckinObj);
        qCheckins.equalTo("parkId", parkId);
        qCheckins.ascending("createdAt");
        qCheckins.find({

            success: function (checkins) {
                park.visitors = checkins;
                var ids = [];
                _.each(checkins, function (checkin) {
                    ids.push(checkin.attributes.userId);
                });

                var Profile = Parse.Object.extend("UserProfile");
                var q = new Parse.Query(Profile);
                q.containedIn("userId", ids);
                q.find({
                    success: function (results) {
                        _.each(results, function (result) {
                            var ci = _.find(checkins, function (checkin) {
                                return checkin.attributes.userId == result.attributes.userId;
                            });
                            ci.profile = result;
                        });
                        callback(park.visitors);
                    }
                });
            }
        });
    },
    loadConversation: function (recpt) {
        state.lastSpokeTimestamp = null;
        state.loadingConversation = recpt;

        var ConvMsgObj = Parse.Object.extend("ConversationMessages");
        var qFrom = new Parse.Query(ConvMsgObj);
        qFrom.equalTo("fromUserId", Parse.User.current().id);
        qFrom.equalTo("toUserId", recpt);
        var qTo = new Parse.Query(ConvMsgObj);
        qTo.equalTo("toUserId", Parse.User.current().id);
        qTo.equalTo("fromUserId", recpt);

        var conv = Parse.Query.or(qFrom, qTo);
        conv.descending("createdAt");
        conv.limit(100);
        conv.find({
            success: function (results) {
                results.reverse();
                dataCache.conversations.push({id: recpt, conv: results});
                _.each(results, function (result) {
                    if (!state.lastSpokeTimestamp || result.createdAt > state.lastSpokeTimestamp) {
                        state.lastSpokeTimestamp = result.createdAt;
                    }
                });
                state.loadingConversation = null;
                if (state.cardId == "messaging") loadCard("messaging", {params: {conversationRecipient: recpt}});

            },
            error: function (results) {
                state.loadingConversation = null;
            }
        });

    },
    pollAndReloadFriendsList: function () {
        if (state.alreadyFriendPolling == true) return;
        state.alreadyFriendPolling = true;
        var callback = function () {
            dataCache.scrollPos = $(".friend-wrapper").scrollTop();
            console.log("scroll: " + dataCache.scrollPos);
            if (state.cardId == "messages") loadCard("messages");
        }
        parseAdapter.getExplicitFriends(callback);

    },
    pollAndAddNewMessages: function () {
        if (state.alreadyPolling == true){
            if(state.pollingBegan < new moment().subtract(5, 'seconds')){

                return;
            }
        }
        state.alreadyPolling = true;
        state.pollingBegan = new moment();
        var conversationRecipient = getParameterByName("conversationRecipient");

        var ConvMsgObj = Parse.Object.extend("ConversationMessages");
        var qTo = new Parse.Query(ConvMsgObj);
        qTo.equalTo("toUserId", Parse.User.current().id);
        qTo.equalTo("fromUserId", conversationRecipient);

        console.log("looking for messages between " + Parse.User.current().id + " and " + conversationRecipient);
        if (state.lastSpokeTimestamp) {
            console.log("with timestamp " + state.lastSpokeTimestamp);
            qTo.greaterThan("createdAt", state.lastSpokeTimestamp);
        }

        qTo.ascending("createdAt");
        qTo.find({
            success: function (results) {
                state.alreadyPolling = false;
                var conv = _.find(dataCache.conversations, function (conv) {
                    return conv.id == conversationRecipient;
                });
                _.each(results, function (result) {
                    var exists = _.find(conv.conv, function (msg) {
                        return msg.id == result.id;
                    });
                    if (!exists) {
                        conv.conv.push(result);
                        if (!state.lastSpokeTimestamp || result.createdAt > state.lastSpokeTimestamp) {
                            state.lastSpokeTimestamp = result.createdAt;
                        }

                        var messageTemplate = _.template($("#messageTemplate").html());
                        var compiled = messageTemplate({msg: result});
                        $(".chat-contents").append(compiled);
                        $(".no_messages").hide();
                    }


                });
                if (results.length > 0) {
                    //there was a new message.
                    var mydiv = $(".messaging").find(".chat-contents");
                    mydiv.scrollTop(10000);


                }


                var u = Parse.User.current();
                if (!u.attributes.lastViewedBark) {
                    u.fetch({
                        success: function (u) {
                            u.set('lastViewedBark', new Date());
                            u.save();
                        }
                    });
                }
                else {
                    u.set('lastViewedBark', new Date());
                    u.save();
                }

                var explicitFriend = _.find(dataCache.explicitFriends, function (f) {
                    return f.attributes.friend2 == conversationRecipient;

                });

                if (explicitFriend) {
                    explicitFriend.set('friend1unread', 0);
                    explicitFriend.save();
                }

            }, error: function (results) {
                state.alreadyPolling = false;
            }
        });

    },
    addToConversation: function (txt, recipientId, callback) {
        var MsgObj = Parse.Object.extend("ConversationMessages");
        var message = new MsgObj();
        message.set("message", txt);
        message.set("toUserId", recipientId);
        message.set("fromUserId", Parse.User.current().id);
        var conv = _.find(dataCache.conversations, function (conv) {
            return conv.id == recipientId;
        });
        conv.conv.push(message);
        callback(message);
        message.save(null, {
            success: function (message) {
                var theirProfile = _.find(dataCache.friends, function (f) {
                    return f.id == recipientId
                });

                var notification_channel_id = "chan_" + recipientId;

                if (theirProfile && theirProfile.attributes.notification_id != "" && typeof(theirProfile.attributes.notification_id) != "undefined") {
                    // try and get the notification channel for their current device.
                    theirProfile.fetch().then(function (z) {
                        notification_channel_id = "chan_n_" + z.attributes.notification_id;

                        Parse.Push.send({
                            channels: [notification_channel_id],
                            data: {badge: "Increment", alert: dataCache.profile.attributes.name + ": " + txt}
                        });
                    });


                }

                // if(callback) callback(message);

                // 'touch' the friendship.
                var FriendObj = Parse.Object.extend("Friends");
                var f1 = new Parse.Query(FriendObj);
                f1.equalTo("friend1", theirProfile.id);
                f1.equalTo("friend2", Parse.User.current().id);

                var f2 = new Parse.Query(FriendObj);
                f2.equalTo("friend2", theirProfile.id);
                f2.equalTo("friend1", Parse.User.current().id);

                // update the explicit friend to suit also!
                /* _.each(dataCache.explicitFriends, function(f){
                 if(f.attributes.friend2 == theirProfile.id){
                 f.fetch();
                 }
                 });*/
                for (var i = 0; i < dataCache.explicitFriends.length; i++) {
                    var f = dataCache.explicitFriends[i];
                    if (f.attributes.friend2 == theirProfile.id || f.attributes.friend1 == theirProfile.id) {
                        f.updatedAt = moment();
                        f.attributes.lastMessage = txt;
                    }
                }

                var fs = Parse.Query.or(f1, f2);
                fs.find({
                    success: function (friends) {
                        if (friends.length == 0) {
                            // these are friendships from before the friends table, make records for them.
                            /*
                             var friendObject = Parse.Object.extend("Friends");
                             var friend = new friendObject();
                             friend.set("friend1",theirProfile.id);
                             friend.set("friend2",Parse.User.current().id);
                             friend.set("lastMessage", txt);
                             friend.save();
                             friends.push(friend);
                             var friend2 = new friendObject();
                             friend2.set("friend1",Parse.User.current().id);
                             friend2.set("friend2",theirProfile.id);
                             friend.set("lastMessage", txt);
                             friend2.save();
                             friends.push(friend2);

                             */
                        }
                        _.each(friends, function (friend) {
                            friend.set("lastMessageId", message.id);
                            friend.set("lastMessage", txt);
                            if (friend.attributes.friend2 == Parse.User.current().id) {
                                friend.increment("friend1unread");
                            }
                            friend.save();
                        });

                        parseAdapter.getExplicitFriends();

                    }
                });


            },
            error: function (message, error) {
                // if(callback) callback(message, error);
            }
        });
    },
    loadDictionary: function () {
        // Loads the key value config pairs from parse.
        var Resources = Parse.Object.extend("Resources");
        var resourcesQ = new Parse.Query(Resources);
        resourcesQ.find({
                success: function (results) {
                    woofer.dynamicConfig = [];
                    _.each(results, function (result) {
                        woofer.dynamicConfig[result.get("key")] = result.get("value");
                    });
                }
            }
        );
    },
    getLikesByMe: function () {
        var Likes = Parse.Object.extend("Likes");
        var q = new Parse.Query(Likes);
        q.equalTo("senderId", Parse.User.current().id);
        q.limit(1000);
        q.find({
            success: function (likes) {

                if (typeof dataCache.haveRetrievedLikesByMe == "undefined") {
                    dataCache.haveRetrievedLikesByMe = false;
                }
                dataCache.LikesByMe = likes;
                // All Likes are back. Now go and fetch profiles.
                var quProfiles = new Parse.Query(Parse.User);
                var profilesToRetrieve = [];
                _.each(dataCache.LikesByMe, function (like) {
                    profilesToRetrieve.push(like.attributes.receiverId);
                });
                quProfiles.containedIn("objectId", profilesToRetrieve);
                quProfiles.limit(1000);
                quProfiles.find({
                    success: function (profilesILiked) {
                        dataCache.likedProfiles = profilesILiked;
                        dataCache.haveRetrievedLikesByMe = true;

                        // Now go load the dogs.
                        // Chuck all user IDs in an array and ask for all of their dogs.
                        var dogsToRetrieve = [];
                        _.each(dataCache.likedProfiles, function (profile) {
                            dogsToRetrieve.push(profile.id);
                        });

                        var Profile = Parse.Object.extend("UserProfile");
                        var dogs = new Parse.Query(Profile);
                        dogs.containedIn("userId", dogsToRetrieve);
                        dogs.find({
                            success: function (dogsReturned) {
                                // Attach the dogs.
                                _.each(dogsReturned, function (dog) {
                                    //find associated profile.
                                    var u = _.find(dataCache.likedProfiles, function (likedProfile) {
                                        return likedProfile.id == dog.attributes.userId;
                                    });
                                    if (u) {
                                        u.dog = dog;
                                    }
                                });
                                state.loadingLikesByMe = false;
                                woofer.loadProfilesAroundCardIfOnWaitingScreen();
                            },
                            error: function (error) {
                                state.loadingLikesByMe = false;
                                woofer.loadProfilesAroundCardIfOnWaitingScreen();
                            }
                        });


                    },
                    error: function (error) {
                        state.loadingLikesByMe = false;

                        woofer.loadProfilesAroundCardIfOnWaitingScreen();
                    }
                });
            }
        });
    },
    saveNewPark: function (park, callback) {
        park.save(null, {
            success: function (park) {
                parseAdapter.leavePawPrintAtPark(park, null);
                dataCache.parksNearby.push(park);
                if (typeof(callback) == "function") {
                    callback(park);
                }
            }
        });
    },
    createExplicitFriendsFromOldFormat: function () {

        //show a 'data is converting' screen.
        // loadCard("friends-upgrading");

        if (dataCache.haveRetrievedLikesByMe && dataCache.haveRetrievedLikesToMe && dataCache.haveRequestedNewFriends) {
            woofer.enumerateFriends();

            // start process
            parseAdapter.createExplicitFriendsWorker();
        }
        else {
            // set an interval to keep checking
            var waitForLikesInterval = window.setInterval(function () {
                if (dataCache.haveRetrievedLikesByMe && dataCache.haveRetrievedLikesToMe && dataCache.haveRequestedNewFriends) {
                    window.clearInterval(waitForLikesInterval);
                    woofer.enumerateFriends();

                    // start process
                    parseAdapter.createExplicitFriendsWorker();
                }

            }, 500);

        }

    },
    createExplicitFriendsWorker: function () {


        _.each(dataCache.friends, function (old_f) {
            var new_f = _.find(dataCache.explicitFriends, function (new_f) {
                return new_f.attributes.friend2 == old_f.id;
            });
            if (!new_f) {
                // there is no new friend for this.

                // delete if existing.

                var friendObject = Parse.Object.extend("Friends");
                var friend = new friendObject();
                friend.set("friend1", old_f.id);
                friend.set("friend2", Parse.User.current().id);
                friend.set("wasMigration", true);
                friend.save();
                var friend = new friendObject();
                friend.set("friend1", Parse.User.current().id);
                friend.set("friend2", old_f.id);
                friend.set("wasMigration", true);
                friend.save();
                console.log("Creating new explicit friend - " + old_f.id);
                dataCache.explicitFriends.push(friend);
            }

        });
        Parse.User.current().set("hasNewFriendList", true);
        Parse.User.current().save(null, {
            success: function (s) {
            }, error: function (e) {
            }
        });
    },
    getExplicitFriends: function (cb) {
		
        if(!Parse.User.current()){
            return;
        }

        var friendObject = Parse.Object.extend("Friends");

        var q = new Parse.Query(friendObject);

        q.equalTo("friend1", Parse.User.current().id);
        q.find({
            success: function (friends) {

                dataCache.haveRequestedNewFriends = true;
                dataCache.explicitFriends = [];
                _.each(friends, function (friend) {
                    dataCache.explicitFriends.push(friend);
                });
                if (typeof cb == "function") {
                    cb()
                }

                if (dataCache.explicitFriends && dataCache.friends && dataCache.explicitFriends.length > 0 && dataCache.friends.length > 0 && dataCache.explicitFriends.length != dataCache.friends.length > 0) {
                    parseAdapter.createExplicitFriendsWorker();
                }

                var messagesCallback = woofer.displayMessagesBadge;
                var friendsCallback = null;
                parseAdapter.getActivitySince(messagesCallback, friendsCallback);
            }
        });


    },
    getLikesToMe: function (thenEnumerateFriends) {
        var Likes = Parse.Object.extend("Likes");
        var q = new Parse.Query(Likes);
        if (typeof dataCache.haveRetrievedLikesToMe == "undefined") {
            dataCache.haveRetrievedLikesToMe = false;
        }
        q.equalTo("receiverId", Parse.User.current().id);
        dataCacheExpiry.likesToMe = new moment().add(30, 'seconds');
        q.find({
            success: function (likes) {
                console.log("Got list of likes.");
                dataCache.LikesToMe = likes;
                state.loadingLikesToMe = false;
                dataCache.haveRetrievedLikesToMe = true;

                if (thenEnumerateFriends && thenEnumerateFriends == true) {
                    woofer.enumerateFriends();
                }
                woofer.loadProfilesAroundCardIfOnWaitingScreen();
            }
        });
    },
    getProfilesNearby: function (distanceKm) {

        state.waitingForProfiles = true;
        var position = dataCache.position;
        var lat = 0;
        var lng = 0;
        if (position) {
            if (position.coords) {
                var lat = position.coords.latitude;
                var lng = position.coords.longitude;
            }
        }
        if (lat == 0 && lng == 0) {
            console.log("Quitting because no position.");
            state.waitingForProfiles = false;
            return;
        }

        if (Object.keys(woofer.dynamicConfig).length == 0) {
            console.log("Quitting because no dynamic config.");
            state.waitingForProfiles = false;
            return;
        }
        if (dataCacheExpiry.profilesNearby < new moment()) {
            state.waitingForProfiles = false;
            console.log("Reset the currently querying because cache expired.");
        }
        state.currentlyQueryingForProfiles = true;
        console.log("Getting profiles nearby.");
        console.log("Dictionary distance was " + woofer.dynamicConfig["profilesNearbyDistanceKm"]);
        if (!distanceKm)     distanceKm = parseInt(woofer.dynamicConfig["profilesNearbyDistanceKm"]);
        if (isNaN(distanceKm)) distanceKm = 8;
        console.log("Loading profiles within " + distanceKm + " kms");
        var point = new Parse.GeoPoint({latitude: lat, longitude: lng});
        var q = new Parse.Query(Parse.User);
        q.withinKilometers("location", point, distanceKm);
        q.notContainedIn("objectId", [Parse.User.current().id]);
        q.find({
            success: function (profilesNearby) {
                dataCacheExpiry.profilesNearby = new moment().add(3, 'minutes');
                console.log("There were " + profilesNearby.length + " profiles nearby.");
                var dogsToRetrieve = [];
                _.each(profilesNearby, function (profileNearby) {

                    dogsToRetrieve.push(profileNearby.id);
                });
                state.waitingForProfiles = false;
                var Profile = Parse.Object.extend("UserProfile");
                var q = new Parse.Query(Profile);
                q.containedIn("userId", dogsToRetrieve);
                q.find({
                    success: function (results) {
                        _.each(results, function (result) {
                            //these are the dogs found.
                            var user = _.find(profilesNearby, function (profileNearby) {
                                return profileNearby.id == result.attributes.userId;
                            });
                            user.dog = result;
                            if (user.dog.photo) {
                                preloadImage(user.dog.photo.url());

                            }

                        });

                        profilesNearby = _.reject(profilesNearby, function (profileNearby) {
                            return profileNearby.dog === undefined || !profileNearby.dog.attributes.name ||
                                profileNearby.dog.attributes.name == "(Enter name)"
                        });
                        profilesNearby = _.reject(profilesNearby, function (profileNearby) {
                            var isLiked = _.some(dataCache.likesByMe, function (l) {
                                if (l.attributes.receiverId == profileNearby.id) {
                                    if (l.attributes.sentiment == true) {
                                        return true;
                                    }
                                }
                            });

                            //if it is liked, it'll get dumped.
                            return isLiked;
                        });
                        dataCache.profilesNearby = profilesNearby;
                        _.each(profilesNearby, function (profileNearby) {
                            // if it already exists in datacache, replace it
                            var exists = false;
                            for (var i = 0; i < dataCache.profilesNearby.length; i++) {
                                if (dataCache.profilesNearby[i].id == profileNearby.id) {
                                    dataCache.profilesNearby[i] = profileNearby;
                                    exists = true;
                                    break;
                                }
                            }
                            // if it doesn't, append to end.
                            if (!exists) {
                                dataCache.profilesNearby[i].push(profileNearby);
                            }
                        });

                        //if I've already liked a profile, ditch it.


                        woofer.loadProfilesAroundCardIfOnWaitingScreen();
                    },
                    error: function (error) {
                        state.waitingForProfiles = false;
                        dataCacheExpiry.profilesNearby = new moment().add(10, 'seconds');
                        debugger;
                    }
                });
            }, error: function (error) {
                state.waitingForProfiles = false;
                dataCacheExpiry.profilesNearby = new moment().add(10, 'seconds');
                debugger;
            }
        });

    },
    tryGetProfile: function () {
        state.requestingMyProfile = true;
        var id = Parse.User.current().id;
        var UserProfile = Parse.Object.extend("UserProfile");
        var UserProfileQ = new Parse.Query(UserProfile);
        UserProfileQ.equalTo("userId", id);
        UserProfileQ.first({
            success: function (profile) {
                if (profile === undefined) {
                    var Profile = Parse.Object.extend("UserProfile");
                    profile = new Profile();
                    profile.set("userId", Parse.User.current().id);
                    profile.save();
                }
                state.requestingMyProfile = false;
                dataCache.profile = profile;

                parseAdapter.subscribe(dataCache.profile.id);


                //preload all images.

                if (dataCache.profile.attributes.photo) {
                    preloadImage(dataCache.profile.attributes.photo.url());
                }
                if (dataCache.profile.attributes.photo2) {
                    preloadImage(dataCache.profile.attributes.photo2.url());
                }
                if (dataCache.profile.attributes.photo3) {
                    preloadImage(dataCache.profile.attributes.photo3.url());
                }
                if (dataCache.profile.attributes.photo4) {
                    preloadImage(dataCache.profile.attributes.photo4.url());
                }

                woofer.displayMyProfile();
            },
            error: function (error) {

                state.requestingMyProfile = false;
                debugger;
            }
        })
    },
    getChannels: function (callback) {
        if (!window.parsePlugin) {
        }
        else {
            window.parsePlugin.getSubscriptions(callback);

        }
    },
    unsubscribe: function (channel) {

        Parse.Cloud.run("unsubscribeFromChannel", {
            installationId: installationID,
            channel: channel
        }, {success: function(){
            console.log('unsubscribed from ' + channel);

        }, error: function(e){

        }});

    },
    subscribe: function (channel) {
        channel = "chan_" + channel;

        if(!installationID){
            // see if we can get the installation ID, then subscribe!
            if(window.parsePlugin){
                window.parsePlugin.initialize(parseConfigApplicationKey, parseConfigClientKey, function() {
                    console.log('success with key ' + parseConfigApplicationKey + ' and client key ' + parseConfigClientKey);

                    window.parsePlugin.getInstallationId(function(id) {
                        installationID = id;

                        Parse.Cloud.run("subscribeToChannel", {
                            installationId: installationID,
                            channel: channel
                        }, {success: function(){

                        }, error: function(e){

                        }});

                    }, function(e) {
                    });

                }, function(e) {
                    console.log('error');
                });
            }
        }
        else{

            Parse.Cloud.run("subscribeToChannel", {
                installationId: installationID,
                channel: channel
            }, {success: function(){

            }, error: function(e){

            }});
        }


    },
    getParksNearby: function (lat, lng, distanceKm, verifiedOnly) {
        if (Object.keys(woofer.dynamicConfig).length == 0) {
            window.setTimeout(function () {
                parseAdapter.getParksNearby(lat, lng);
            }, 1000);
            return;
        }


        var position = dataCache.position;
        if (!position || !position.coords) {
            console.log("Can't get parks nearby because no position.");
            return;
        }
        var lat = position.coords.latitude;
        var lng = position.coords.longitude;
        if (dataCache.lastLat == lat && dataCache.lastLng == lng) {
            //already have queried with these values, just quit.
            return;
        }
        dataCache.lastLat = lat;
        dataCache.lastLng = lng;

        console.log("getting parks nearby.");
        if (!verifiedOnly)   verifiedOnly = true;
        if (!distanceKm)     distanceKm = woofer.dynamicConfig["parksNearbyDistanceKm"];

        var point = new Parse.GeoPoint({latitude: lat, longitude: lng});
        var Park = Parse.Object.extend("Park");
        var parkQ = new Parse.Query(Park);
        parkQ.withinKilometers("Location", point, distanceKm);
        parkQ.find({
            success: function (parksNearby) {
                dataCache.parksNearby = parksNearby;
            },
            error: function (error) {
                debugger;
            }
        });

        var parkTooClose = new Parse.Query(Park);
        parkTooClose.withinKilometers("Location", point, 0.5);
        parkTooClose.find({
            success: function (parksTooClose) {
                dataCache.parksTooClose = parksTooClose;
            }
        });
    },
    init: function () {
        Parse.$ = $;
        Parse.initialize(parseConfigApplicationKey,
            parseConfigJavascriptKey);
        parseAdapter.loadDictionary();

        var dictionaryLoader = window.setInterval(function () {
            if (Object.keys(woofer.dynamicConfig).length == 0) {
                parseAdapter.loadDictionary();
            }
            else {
                window.clearInterval(dictionaryLoader);
            }
        }, 2000);
    }
};